-- Name: BSU_main
-- Author: Chissel

source(g_currentModDirectory .. "src/BSU_bunkerSiloUtilities.lua")
source(g_currentModDirectory .. "src/BSU_bunkerSiloOverwrites.lua")

source(g_currentModDirectory .. "src/BSU_addFillTypes.lua")
source(g_currentModDirectory .. "src/BSU_addHeightTypes.lua")

source(g_currentModDirectory .. "src/BSU_bunkerSiloExtension.lua")

source(g_currentModDirectory .. "src/events/BSU_reopenCoverEvent.lua")
source(g_currentModDirectory .. "src/events/BSU_closeCoverEvent.lua")
source(g_currentModDirectory .. "src/events/BSU_clearAreaEvent.lua")
source(g_currentModDirectory .. "src/events/BSU_changeCoverEvent.lua")

local function interactionTriggerCallback(self, triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
    BSU_bunkerSiloUtilities.interactionTriggerCallback(self, onEnter, onLeave)
end

local function getIsActivatable(self, superFunc)
    local returnValue = superFunc(self)
    BSU_bunkerSiloUtilities.getIsActivatable(self.bunkerSilo)
    return returnValue
end

local function addBunkerSiloExtension()
    BunkerSilo.registerSavegameXMLPaths = Utils.appendedFunction(BunkerSilo.registerSavegameXMLPaths, BSU_bunkerSiloExtension.registerSavegameXMLPaths)
    BunkerSilo.saveToXMLFile = Utils.appendedFunction(BunkerSilo.saveToXMLFile, BSU_bunkerSiloExtension.saveToXMLFile)
    BunkerSilo.loadFromXMLFile = Utils.appendedFunction(BunkerSilo.loadFromXMLFile, BSU_bunkerSiloExtension.loadFromXMLFile)
    BunkerSilo.readStream = Utils.appendedFunction(BunkerSilo.readStream, BSU_bunkerSiloExtension.readStream)
    BunkerSilo.writeStream = Utils.appendedFunction(BunkerSilo.writeStream, BSU_bunkerSiloExtension.writeStream)
end

local function init()
    addBunkerSiloExtension()

    BunkerSilo.interactionTriggerCallback = Utils.appendedFunction(BunkerSilo.interactionTriggerCallback, interactionTriggerCallback)
    BunkerSiloActivatable.getIsActivatable = Utils.overwrittenFunction(BunkerSiloActivatable.getIsActivatable, getIsActivatable)
    BunkerSilo.setState = Utils.overwrittenFunction(BunkerSilo.setState, BSU_bunkerSiloOverwrites.setState)
    BunkerSilo.update = Utils.appendedFunction(BunkerSilo.update, BSU_bunkerSiloOverwrites.update)

    FillTypeManager.loadMapData = Utils.overwrittenFunction(FillTypeManager.loadMapData, BSU_addFillTypes.loadMapData)
    DensityMapHeightManager.loadMapData = Utils.overwrittenFunction(DensityMapHeightManager.loadMapData, BSU_addHeightTypes.loadMapData)
end

init()